﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Diagnostics;

namespace aspbasics1.pages
{
	public partial class basic1 : System.Web.UI.Page
	{
		protected void Page_Load(object sender, EventArgs e) {
			// These have nothing to do with the example. Just a few notes on C#.
			
			// Everything is an Object in C#, though the "primitives" are passed by
			// value, just as they are in Java. However, can pass primitives by 
			// reference (not shown)
			int x = 10;
			string msg = x.ToString();

			// The List class is like Java's ArrayList.
			List<int> ints = new List<int>() { 1, 2, 3 };
			ints.Add(99);

			// There is no getter. Instead, C# uses an indexer, which is a special type
			// of property that (in this case) allows access to the collection using
			// array notation.
			int y = ints[2];

			// Indexed loop
			for(int i=0; i<ints.Count; i++) {
				Debug.Write(ints[i] + " ");
			}

			// foreach loop
			foreach(int i in ints) {
				Debug.Write(i + " ");
			}
			Console.WriteLine("y=" + y);

			
		}

		protected void btnPurchase_Click(object sender, EventArgs e)
		{
			// Retrieve data from screen and format

			// Retrieve name
			String name = txtName.Text;
			// Format name
			name = String.Format("name: {0}\r\n", name);

			// Get name of movie (Text) and year (Value).
			// Note Value must be unique for proper operation of the drop down.
			// In this case the years are unique (but of course in general, 
			// the release dates would not be unique)
			String movieName = ddlMovies.SelectedItem.Text;
			String movieYear = ddlMovies.SelectedValue;
			// Format movie info
			String movie = String.Format("Move: {0}, released: {1}\r\n", movieName, movieYear);

			// Get reservation date and format
			String date = cal.SelectedDate.ToShortDateString();
			date = String.Format("Date: {0}\r\n", date);

			// Get number of tickets, calculate price and format
			int numTixs = Convert.ToInt32(txtNumTixs.Text);
			double totalTixPrice = numTixs * 8.99;
			String tixs = String.Format("Num Tixs: {0}, total price: {1:c}\r\n", numTixs, totalTixPrice);

			// Initialize string to hold the "snacks" ordered (popcorn, soda, raisinettes)
			String snacksList = "";
			double snacksPrice = 0.0;

			// Loop through snacks checkboxes, if selected, add to snack list and increment total cost
			foreach (ListItem li in cblSnacks.Items)
			{
				if (li.Selected)
				{
					snacksList += li.Text + ", ";
					snacksPrice += Convert.ToDouble(li.Value);
				}
			}

			// Get seating choice
			String seatChoice = "Seat type: " + rblSeats.SelectedValue + "\r\n";


			// Build a string to hold snack list and price.
			String snacks = "";
			if (snacksList.Length > 0)
			{
				snacks = String.Format("Snacks: {0}, total price: {1:c}\r\n", snacksList, snacksPrice);
			}

			// Build final output string.
			String msg = name + movie + date + tixs + seatChoice + snacks;
			// Display output
			txtMsg.Text = msg;

		}
	}
}