﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Diagnostics;

namespace aspbasics1.pages
{
	public partial class listExample : System.Web.UI.Page
	{
		protected void Page_Load(object sender, EventArgs e) {
			// These have nothing to do with the example. Just a few notes on C#.
			
			// Everything is an Object in C#, though the "primitives" are passed by
			// value, just as they are in Java. However, can pass primitives by 
			// reference (not shown)
			int x = 10;
			string msg = x.ToString();

			// The List class is like Java's ArrayList.
			// ToArray turns list into an int array, and the array's
			// ToString returns the string representation
			List<int> ints = new List<int>() { 1, 2, 3 };
			msg = "List<int> ints = new List<int>() { 1, 2, 3 };" + Environment.NewLine;
			msg += "--> " + string.Join(",", ints.ToArray());
			msg += Environment.NewLine + Environment.NewLine;

			ints.Add(99);
			msg += "ints.Add(99);" + Environment.NewLine;
			msg += "--> " + string.Join(",", ints.ToArray());
			msg += Environment.NewLine + Environment.NewLine;

			// There is no getter. Instead, C# uses an indexer, which is a special type
			// of property that that allows access to the collection using an integer (in this case)
			// index and array notation.
			int y = ints[2];

			// Remove an object
			ints.Remove(2);
			msg += "ints.Remove(2);" + Environment.NewLine;
			msg += "--> " + string.Join(",", ints.ToArray());
			msg += Environment.NewLine + Environment.NewLine;

			// Add a few more
			ints.Add(7);
			msg += "ints.Add(7);" + Environment.NewLine;
			msg += "--> " + string.Join(",", ints.ToArray());
			msg += Environment.NewLine + Environment.NewLine;

			// Remove at an index
			ints.RemoveAt(0);
			msg += "ints.RemoveAt(0);" + Environment.NewLine;
			msg += "--> " + string.Join(",", ints.ToArray());
			msg += Environment.NewLine + Environment.NewLine;

			// Indexed loop
			msg += "for(int i=0; i<ints.Count; i++) {" + Environment.NewLine;
			msg += "    msg += ints[i] + \" \";" + Environment.NewLine;
			msg += "}" + Environment.NewLine;
			msg += "--> ";
			for (int i=0; i<ints.Count; i++) {
				msg += ints[i] + " ";
			}
			msg += Environment.NewLine + Environment.NewLine;

			// foreach loop
			msg += "foreach (int val in ints) {" + Environment.NewLine;
			msg += "    msg += val + \" \";" + Environment.NewLine;
			msg += "}" + Environment.NewLine;
			msg += "--> ";
			foreach (int val in ints) {
				msg += val + " ";
			}
			msg += Environment.NewLine + Environment.NewLine;
			txtMsg.Text = msg;


		}

	}
}