﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="listboxCV1.aspx.cs" Inherits="AspBasics1.listboxCV1" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>ListBox with Custom Validation</title>
    <link href="../site.css" rel="stylesheet" type="text/css" />
    <script type="text/javascript" language="javascript">
	// Makes sure exactly 2 names are selected.
        function ChooseTwoNames(source, arguments) {
            var numSelected = 0;
            var lst = document.getElementById("lstNames2");

            for (i = 0; i < lst.length; i++) {
                if (lst.options[i].selected) {
                    numSelected++;
                }
            }
            if (numSelected == 2) {
                arguments.IsValid = true;
            }
            else {
                arguments.IsValid = false;
            }

            if (numSelected == 0) {
                alert("ClientValidate function\r\nMust select two names");
            }
            else if (numSelected == 1) {
                alert("ClientValidate function:\r\nMust select one more name");
            }
            else if (numSelected > 2) {
                alert("ClientValidate function:\r\nMust select exactly two names");
            }
        }
	</script>
    
    <link href="../site.css" rel="stylesheet" type="text/css" />
    </head>
<body>
    <!-- #Include File="header2.txt" -->
    <form id="form1" runat="server">
    <div>
    <p>In the example below, the user is required to pick exactly two names from the 
        list before the page will postback. It utilizes a CustomValidator to invoke a 
        custom JavaScript function on the client side. This function, itself (rather 
        annoyingly) displays &quot;alerts&quot;. The CustomValidator also displays its own error 
        message in the page. It also uses a RequiredField Validator. </p>
        
    <p>The Reset button&#39;s CausesValidation is set to false. Thus, when Reset is pressed, no validation occurs.</p>
    
    <table cellpadding="3" cellspacing="0">
    <tr>
        <td>
            Choose 2<br />
            <asp:ListBox ID="lstNames2" runat="server" accessKey="q" SelectionMode="Multiple" Width="160px" style="font-family: Verdana">
                <asp:ListItem Value="870238431">Argyle, Pam</asp:ListItem>
                <asp:ListItem Value="870473841">Benton, Nell</asp:ListItem>
                <asp:ListItem Value="870492831">Houghton, Ralph</asp:ListItem>
                <asp:ListItem Value="870531192">Jerslow, Michael</asp:ListItem>
                <asp:ListItem Value="870669231">Leher, Tim</asp:ListItem>
                <asp:ListItem Value="870602395">Miney, Sandra</asp:ListItem>
                <asp:ListItem Value="870045912">O&#39;Rielly, Tina</asp:ListItem>
                <asp:ListItem Value="870337865">Walters, Norm</asp:ListItem>
            </asp:ListBox>                        
        </td>
                
        <td>
            <table cellpadding="3" cellspacing="0">
                <tr>
                    <td>
                        <asp:Button ID="btnSelect" runat="server" onclick="btnSelect_Click" 
                        Width="56px" style="font-family: Verdana" Text="Select" />
                    </td>
                </tr>
                            
                <tr>
                    <td>
                        <asp:Button ID="btnReset" runat="server" CausesValidation="False" 
                        onclick="btnReset_Click" Width="56px" style="font-family: Verdana" Text="Reset" />
		                &nbsp;
		                <asp:Label ID="Label1" runat="server" Text="Causes Validation"></asp:Label>
		                <asp:RadioButtonList ID="rblCausesValidation" runat="server" RepeatLayout="Flow" RepeatDirection="Horizontal" OnSelectedIndexChanged="rblCausesValidation_SelectedIndexChanged">
			                <asp:ListItem>True</asp:ListItem>
			                <asp:ListItem Selected="True">False</asp:ListItem>
		                </asp:RadioButtonList>
                    </td>
                </tr>
            </table>
        </td>
    </tr>
    </table>
    <p>
        <asp:TextBox ID="txtSelections" runat="server" Height="136px" 
        TextMode="MultiLine" Width="265px"></asp:TextBox>                        
    </p>
    <p>
        <asp:CustomValidator ID="cvNumNames" runat="server" 
                ClientValidationFunction="ChooseTwoNames" ControlToValidate="lstNames2" 
                ErrorMessage="CustomValidator: Must choose exactly 2 names" 
                style="font-family: Verdana" Font-Bold="True" ForeColor="Red">CustomValidator: Must choose exactly 2 names</asp:CustomValidator>
    </p>
    
    <p>
        <asp:RequiredFieldValidator ID="RequiredFieldValidator1" runat="server" 
                ControlToValidate="lstNames2" 
                ErrorMessage="RequiredFieldValidator: Must choose exactly 2 names" Font-Bold="True" ForeColor="Red">RequiredFieldValidator: 
            Text: Must choose exactly 2 names</asp:RequiredFieldValidator>
    </p>
    
    </div>
    </form>
</body>
</html>
