﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="validators.aspx.cs" Inherits="aspbasics1.pages.validators" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Validators Exampe</title>
    <link href="../site.css" rel="stylesheet" type="text/css" />
    <script type="text/javascript">
		function CheckNameLength(source, arguments) {
            // Could access text box directly. Howerver, no need to. See below.
            // is the value of the textbox.
            // var tb = document.getElementById("TextBox3");
            // var tbval = tb.value;
            // alert(tbval.length);

            // The "arguments" argument to the function has a Value property that
            // is the value of the textbox.
            var len = arguments.Value.length;
            if ((len < 2) || (len > 8)) {
				alert("Name must be between 2 and 8 characters");
                // Set "IsValid" to false to ensure that no postback occurs.
                arguments.IsValid = false;
            }
			else
                // Set "IsValid" to true to allow the postback.s
                arguments.IsValid = true;
        }
    
    </script>


    <style type="text/css">
        .style1
        {
            border-style: solid;
            border-width: 2px;
        }
        .style2
        {
            color: #0066FF;
        }
        .style3
        {
            color: #0066FF;
            font-size: smaller;
        }
        .style4
        {
            font-size: smaller;
        }
    </style>


</head>
<body>
		<form id="form1" runat="server">
		<!-- #Include File="header2.txt" -->
        <p>
            <strong>Validators Examples</strong></p>

        <table class="style1">
            <tr>
                <td>
                    <span class="style3"><strong>RangeValidator &amp; RequiredFieldValidator</strong></span><br />
                    Supply a number between 0 and 10
                    
                    <asp:TextBox ID="TextBox1" runat="server" Width="45px"></asp:TextBox>&nbsp;
                    
                    <asp:RangeValidator ID="RangeValidator1" runat="server" 
                    ControlToValidate="TextBox1" ErrorMessage="Must be an Integer between 0 and 10" 
                    ForeColor="Red" MaximumValue="10" MinimumValue="0" Type="Integer">*</asp:RangeValidator>

                    <asp:RequiredFieldValidator ID="RequiredFieldValidator1" runat="server" 
                    ControlToValidate="TextBox1" ErrorMessage="Must supply a value" ForeColor="Red">*</asp:RequiredFieldValidator>
                </td>
            </tr>
        </table>

        <br />

        <table class="style1">
            <tr>
                <td>
                    <span class="style3"><strong>ComapreValidator &amp; RequiredFieldValidator</strong></span><br />
                    Supply another integer larger than the preceding one
                    
                    <asp:TextBox ID="TextBox2" runat="server" Width="45px"></asp:TextBox>&nbsp;
                    
                    <asp:CompareValidator ID="CompareValidator1" runat="server" 
                    ControlToCompare="TextBox1" ControlToValidate="TextBox2" 
                    ErrorMessage="Value must be an integer larger than previous value" 
                    ForeColor="Red" Operator="GreaterThan" Type="Integer">*</asp:CompareValidator>

                    <asp:RequiredFieldValidator ID="RequiredFieldValidator2" runat="server" 
                    ControlToValidate="TextBox2" ErrorMessage="Must supply a value" ForeColor="Red">*</asp:RequiredFieldValidator>
                </td>
            </tr>
        </table>

        <br />

        <table class="style1">
            <tr>
                <td>
                    <span class="style2"><strong><span class="style4">CustomValidator</span><br /></strong></span>
                    Supply your name
                    
                    <asp:TextBox ID="TextBox3" runat="server"></asp:TextBox>
                    
                    <asp:CustomValidator ID="CustomValidator1" runat="server" 
                    ClientValidationFunction="CheckNameLength" ControlToValidate="TextBox3" 
                    ErrorMessage="Name must be between 2 and 10 characters long" ForeColor="Red" OnServerValidate="CustomValidator1_ServerValidate">*</asp:CustomValidator>
                </td>
            </tr>
        </table>

        <br />

        <table class="style1">
            <tr>
                <td>
                    <span class="style2"><strong><span class="style4">RegularExpressionValidator</span><br /></strong></span>
                    Supply your phone number (ddd-dddd)
                    
                    <asp:TextBox ID="TextBox4" runat="server"></asp:TextBox>
                    
                    <asp:RegularExpressionValidator ID="RegularExpressionValidator1" runat="server" 
                    ControlToValidate="TextBox4" ErrorMessage="Must be in form ddd-dddd" 
                    ForeColor="Red" ValidationExpression="\d{3}-\d{4}">*</asp:RegularExpressionValidator>
                </td>
            </tr>
        </table>
        <p>
            <asp:Button ID="btnEnter" runat="server" Text="Enter" onclick="btnEnter_Click" />
            
            <asp:Button ID="btnTryAgain" runat="server" onclick="btnTryAgain_Click" Text="Try Again?" Visible="False" />
        </p>
        <p>
            Validation Summary: 
            <asp:Label ID="lblMsg" runat="server" ForeColor="Blue" Text="Congratulations, data entry is correct!" Visible="False"></asp:Label>
        </p>
        
            <asp:ValidationSummary ID="ValidationSummary1" runat="server" ForeColor="Red" 
            HeaderText="Please correct the following errors:" />
        </form>
</body>
</html>
